%define name secondlife
%define version 1.18.2.1
%define beta 0
%define snapshot 0
%if %{snapshot}
%define release %mkrel 0.%{snapshot}.1
%define oname slviewer-src
%define distname %{oname}-%{snapshot}
%else
%define release %mkrel 2
%if %{beta}
%define oname slviewer-src-beta
%else
%define oname slviewer-src
%endif
%define distname %{oname}-%{version}
%endif
%define Summary Second Life online 3-D virtual world
%define sl_arch %(echo %{_target_cpu}|sed -e "s/\\(i.86\\|athlon\\)/i686/")

# we use private symbols from resolv.a
%define _requires_exceptions GLIBC_PRIVATE

Summary: %{Summary}
Name: %{name}
Version: %{version}
Release: %{release}
Source0: http://secondlife.com/developers/opensource/downloads/%{distname}.tar.gz
# missing files for png support, from https://jira.secondlife.com/browse/VWR-79
Source1: https://jira.secondlife.com/secure/attachment/10030/png-support-20070127a.zip
Patch0: slviewer-src-1.15.0.0-releasefiles.patch
Patch1: slviewer-src-1.17.1.0-size_t.patch
Patch2: slviewer-src-1.18.2.0-const_char.patch
Patch4: slviewer-src-1.18.2.0-resolv.patch
Patch5: slviewer-1.18.2.1-nomanifest.patch
Patch7: slviewer-src-1.18.2.0-datapath.patch
# adapted from http://www.haxxed.com/code/slviewer-1.17.0.12-openal-20070625.patch
Patch9: slviewer-1.18.2.0-openal-20070625.patch
Patch10: slviewer-src-1.18.2.0-get_factor.patch
License: GPL
Group: Games/Other
Url: http://secondlife.com/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: SDL-devel
BuildRequires: apr-util-devel bison boost-devel curl-devel elfio-devel expat-devel
BuildRequires: freetype2-devel gtk2-devel jpeg-devel flex libxmlrpc-devel
BuildRequires: mesaglu-devel oggvorbis-devel openjpeg-devel scons zlib-devel
BuildRequires: freealut-devel openal-devel google-perftools-devel
BuildRequires: glibc-static-devel
#BuildRequires: libgstreamer-plugins-base-devel
BuildConflicts: freetype-devel
Requires: fonts-ttf-bitstream-vera
Requires: secondlife-artwork

%description
Second Life is an online 3-D virtual world entirely built and owned by
its residents.

%prep
%setup -q -n linden -a 1
%if %{beta}
%patch0 -p1 -b .releasefiles
%endif
%patch1 -p1 -b .size_t
%patch2 -p1 -b .const_char
%patch4 -p1 -b .resolv
%patch5 -p1 -b .nomanifest
%patch7 -p1 -b .datapath
%patch9 -p1 -b .openal
%patch10 -p1 -b .get_factor

cp -a png-support-20070127a/linden/indra/llimage/* indra/llimage/
perl -pi -e 's/LLImage\.h/llimage.h/' indra/llimage/*png*
perl -pi -e 's,libpng/png\.h,png.h,' indra/llimage/*png*

mkdir libraries/include/expat
ln -s %{_includedir}/expat.h libraries/include/expat
mkdir -p libraries/include/llfreetype2/freetype
ln -s %{_includedir}/ft2build.h libraries/include/llfreetype2/freetype
mkdir libraries/include/jpeglib
ln -s %{_includedir}/{jpeglib,jerror}.h libraries/include/jpeglib
> libraries/include/jpeglib/jinclude.h
mkdir libraries/include/openjpeg
ln -s %{_includedir}/openjpeg.h libraries/include/openjpeg
mkdir libraries/include/xmlrpc-epi
ln -s %{_includedir}/xmlrpc.h libraries/include/xmlrpc-epi
mkdir libraries/include/zlib
ln -s %{_includedir}/zlib.h libraries/include/zlib

%build
%if %mdkversion < 200710
  CLIENT_CPPFLAGS="$CLIENT_CPPFLAGS -I/usr/include/freetype2 -I/usr/include/libpng12"
  export CLIENT_CPPFLAGS
%endif

pushd indra
scons BUILD=releasefordownload BTARGET=client STANDALONE=yes ARCH=%{sl_arch} DISTCC=no MOZLIB=no FMOD=no GSTREAMER=no
popd

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_gamesbindir}
install -m 755 indra/newview/%{name}-*-bin-globalsyms %{buildroot}%{_gamesbindir}/%{name}.bin
install -m 755 indra/newview/linux_tools/wrapper.sh %{buildroot}%{_gamesbindir}/%{name}

install -d %{buildroot}%{_gamesdatadir}/%{name}/fonts
pushd indra/newview
  cp -a app_settings skins \
        featuretable.txt gpu_table.txt \
        %{buildroot}%{_gamesdatadir}/%{name}
popd

install -m 644 scripts/messages/message_template.msg %{buildroot}%{_gamesdatadir}/%{name}/app_settings/
for f in MtBdLfRg.ttf MtBkLfRg.ttf profontwindows.ttf unicode.ttf; do
  ln -s /usr/share/fonts/TTF/Vera.ttf %{buildroot}%{_gamesdatadir}/%{name}/fonts/$f
done

mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mandriva-%{name}.desktop << EOF
[Desktop Entry]
Name=Second Life
Comment=%{Summary}
Exec=soundwrapper %{_gamesbindir}/%{name}
Icon=%{_gamesdatadir}/%{name}/res/ll_icon.ico
Terminal=false
Type=Application
Categories=Game;AdventureGame;X-MandrivaLinux-MoreApplications-Games-Adventure;
EOF

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc indra/newview/linux_tools/client-readme.txt indra/newview/releasenotes.txt indra/newview/lsl_guide.html
%{_gamesbindir}/%{name}
%{_gamesbindir}/%{name}.bin
%defattr(0644,root,root,0755)
%{_gamesdatadir}/%{name}
%{_datadir}/applications/mandriva-%{name}.desktop


%changelog
* Sat Sep 29 2007 Olivier Blin <oblin@mandriva.com> 1.18.2.1-2mdv2008.0
+ Revision: 93866
- do not run manifest script that builds a tarball
- build with "releasefordownload" type so that agni grid is selected by default (#34259)
- remove agni patch, does not work

* Tue Sep 25 2007 Olivier Blin <oblin@mandriva.com> 1.18.2.1-1mdv2008.0
+ Revision: 92780
- 1.18.2.1

* Fri Sep 14 2007 Olivier Blin <oblin@mandriva.com> 1.18.2.0-2mdv2008.0
+ Revision: 85624
- try to use agni as default grid
- ignore libc.so.6(GLIBC_PRIVATE) requires (#33580)

* Fri Sep 14 2007 Olivier Blin <oblin@mandriva.com> 1.18.2.0-1mdv2008.0
+ Revision: 85476
- do not package dynamic libs (not built anymore)
- buildrequire glibc-static-devel (for libresolv.a)
- pass arch to scons script (fix x86_64 detection)
- link with static libresolv (ns_initparse is not available in dynamic lib)
- fix getDopplerFactor() (broke build and was broken per se)
- fix build with Werror (use const char when appropriate)
- do not build with gstreamer for now
- rediff OpenAL patch (adapt SConstruct)
- rediff datapath patch
- drop ELFIO patch (merged upstream)
- 1.18.2.0

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Fri Jun 29 2007 Olivier Blin <oblin@mandriva.com> 1.17.2.0-1mdv2008.0
+ Revision: 45673
- 1.17.2.0
- fix perms (broken further by fix-eol helper)

* Thu Jun 28 2007 Olivier Blin <oblin@mandriva.com> 1.17.1.0-2mdv2008.0
+ Revision: 45390
- install libraries

* Wed Jun 27 2007 Olivier Blin <oblin@mandriva.com> 1.17.1.0-1mdv2008.0
+ Revision: 45230
- remove useless gcc build hack now that we build a standalone release
- fix build on x86_64 with Werror
- build with STANDALONE=yes (to use system packages with pkg-config)
- remove explicit pkg-config call (now handled in upstream SConstruct)
- buildrequire google-perftools-devel for tcmalloc library
- add missing png support files
- update and adapt openal patch
- replace fmod patch by new FMOD=no build option
- remove mozlib patch (merged upstream)
- rediff boost/ELFIO/datapath patches
- remove merged cplusplus yylex patch
- 1.17.1.0

* Tue May 15 2007 Olivier Blin <oblin@mandriva.com> 1.15.0.2-4mdv2008.0
+ Revision: 26901
- link with alut
- buildrequires freealut/openal-devel
- OpenAL support (from Callum Lerwick, sldev ML)

* Sat Apr 28 2007 Olivier Blin <oblin@mandriva.com> 1.15.0.2-3mdv2008.0
+ Revision: 19000
- update summary and description
- add XDG menu entry (now that the game is stable enough)

* Sat Apr 28 2007 Olivier Blin <oblin@mandriva.com> 1.15.0.2-2mdv2008.0
+ Revision: 18932
- use Vera font to replace removed MtBdLfRg/MtBkLfRg/profontwindows fonts
- do not package character, fonts and res-sdl anymore
- 1.15.0.2
- skip release file only in beta versions
- fix beta support

* Mon Apr 23 2007 Olivier Blin <oblin@mandriva.com> 1.15.0.0-1mdv2008.0
+ Revision: 17562
- fix build when mozlib is not used (from upstream ML)
- do not build llfloaterrate and llviewerreputation in this beta release, they are only included in final releases
- 1.15.0.0
- handle beta releases in specfile
- rediff boost/fmod/ELFIO patches
- drop extra qualifiers and uictrlfactory patches


* Thu Mar 29 2007 Olivier Blin <oblin@mandriva.com> 1.14.0.0-1mdv2007.1
+ Revision: 149324
- 1.14.0.0 (and drop patches merged upstream)

* Mon Mar 12 2007 Olivier Blin <oblin@mandriva.com> 1.13.4.7-2mdv2007.1
+ Revision: 141461
- make openjpeg decoding a lot faster (from upstream Jira, VWR-123)
- 1.13.4.7
- readd wrongly dropped fmod patch
- fix build errors (extra qualifications and class declarations)
- make wrapper pass arguments to secondlife.bin
- disable mozlib (would require ubrowser libs)
- require secondlife-artwork instead of secondlife-static-data

  + Emmanuel Andry <eandry@mandriva.org>
    - oops, forgot to change version to 1.13.3
    - New snapshot
    - drop patch 3
    - rediff patch 7

* Mon Jan 29 2007 Olivier Blin <oblin@mandriva.com> 1.13-0.20070126a.3mdv2007.1
+ Revision: 115036
- use bison instead of byacc
- 20070126a (and drop merged upstream patches)
- add missing includes for 2007.0 (thanks to Hawkwind for the report)

* Wed Jan 10 2007 Olivier Blin <oblin@mandriva.com> 0.1-0.20070108c.3mdv2007.1
+ Revision: 106864
- add missing message template (the game now starts, but is slow)

* Tue Jan 09 2007 Olivier Blin <oblin@mandriva.com> 0.1-0.20070108c.2mdv2007.1
+ Revision: 106753
- require secondlife-static-data
- fix x86_64 build

* Tue Jan 09 2007 Olivier Blin <oblin@mandriva.com> 0.1-0.20070108c.1mdv2007.1
+ Revision: 106493
- build for i586 only now, I will fix x86_64 build later
- buildrequire mesaglu-devel
- simplify (silent)
- buildrequire flex
- use Vera.ttf as default font
- add wrapper script
- add more doc
- add feature/gpu tables
- add data files
- buildrequire curl-devel
- add readme
- buildrequire apr-util-devel
- install in games*bin*dir
- buildrequires SDL-devel, mesagl-devel, oggvorbis-devel
- buildrequire apr-devel
- buildrequire scons
- initial Mandriva release
- Create secondlife

